"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _fs = _interopRequireDefault(require("fs"));

var _rimraf = _interopRequireDefault(require("rimraf"));

var _unzipper = _interopRequireDefault(require("unzipper"));

var _asyncRetry = _interopRequireDefault(require("async-retry"));

var _util = require("util");

var _downloadDynamodbAsync = _interopRequireDefault(require("../repository/download-dynamodb-async"));

var _chalk = require("chalk");

var _path = _interopRequireDefault(require("path"));

var _os = _interopRequireDefault(require("os"));

var rimrafAsync = (0, _util.promisify)(_rimraf["default"]);

var execute = function execute() {
  return new Promise(function (resolve, reject) {
    if (_fs["default"].existsSync(_path["default"].join(_os["default"].tmpdir(), 'dynamodb-local'))) {
      return resolve();
    }

    console.log((0, _chalk.yellow)('\n================================='));
    console.log((0, _chalk.yellow)('Unzipping dynamodb local...'));
    console.log((0, _chalk.yellow)('================================='));

    _fs["default"].createReadStream(_path["default"].join(_os["default"].tmpdir(), 'dynamodb-local.zip')).pipe(_unzipper["default"].Extract({
      path: _path["default"].join(_os["default"].tmpdir(), 'dynamodb-local')
    })).on('finish', resolve).on('error', reject);
  });
};

var _default = function _default() {
  return (0, _asyncRetry["default"])(
  /*#__PURE__*/
  function () {
    var _ref = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee(bail) {
      var result;
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              _context.prev = 0;
              _context.next = 3;
              return execute();

            case 3:
              result = _context.sent;
              _context.next = 16;
              break;

            case 6:
              _context.prev = 6;
              _context.t0 = _context["catch"](0);
              console.log((0, _chalk.red)('\n================================='));
              console.log((0, _chalk.red)('Unzipping error...'));
              console.log((0, _chalk.red)('=================================')); // retry previous step

              _context.next = 13;
              return rimrafAsync(_path["default"].join(_os["default"].tmpdir(), 'dynamodb-local.zip'));

            case 13:
              _context.next = 15;
              return (0, _downloadDynamodbAsync["default"])();

            case 15:
              throw _context.t0;

            case 16:
              return _context.abrupt("return", result);

            case 17:
            case "end":
              return _context.stop();
          }
        }
      }, _callee, null, [[0, 6]]);
    }));

    return function (_x) {
      return _ref.apply(this, arguments);
    };
  }(), {
    retries: 1
  });
};

exports["default"] = _default;